;Teil 5 des Basicinterpreters



;***** DIE BASICBEFEHLE und FUNKTIONEN *****

BYE:
;BYE   zurck zum DOS
 LDS  DX,[SAV_INT] ;DS=[SAV_INT+2]  Int$1b
 MOV  AX,0251BH ;INT$21 Func$25: setze Int.-vektor
 INT  021H
 push cs
 pop ds
 lds dx,[SAV_INT+4] ;DS=[SAV_INT+6]  Int$24
 mov ax,02524h
 int 021h
 push cs
 pop ds
 MOV  BX,CS
 MOV  DS,BX
 mov  si,[VARREG]
 mov  al,[si+44] ;Returncode aus Bit7-0 von Var. ER
 mov  ah,04ch    ;INT$21 Func$4C: beende Programm
 INT  021H


NEW:
;NEW   Programm lschen (und beenden)
 MOV  W[TXTUNF],TXTBGN
 JMP  RSTART


BEND:
;END   Programm beenden
 JMP  RSTART


RUN:
;RUN   Programm starten
 call RUNINIT
 mov  [PRT_WAY],ax
 mov  w[PRT_SPC],1 ;Standardformat fr Zahlenausgabe
 mov  si,TXTBGN    ;erste Zeile
 jmp RUNTHISL


RUNNEXTL:
;berspringe diese Zeile, Ausfhrung der nchsten
;fr DATA, IF, REM
 call FNDSKP ;suche nchste Zeile
 jnc RUNTHISL
 jmp RSTART  ;Programmende erreicht


FINISH:
;Hierher springt jeder Befehl wenn er fertig ist.
;Falls der Befehl alle seine Daten verarbeitet hat,
;wird der nchste Befehl ausgefhrt, sonst Fehlermeldung.
 cld
 lodsb
 cmp al,0eh
 jnz finish1
runsamel:
;nchsten Befehl in der gleichen Zeile ausfhren
 test b[PRG_BRK],0ffh ;Abbruch ?
 jnz finish4 ; ja
 inc si      ;berspringe Lngenbyte
 jmp TEXEC   ;fhre Token aus
finish1:
 cmp al,0dh
 jnz finish2 ;nicht alle Daten verarbeitet
RUNTHISL:
;neue Zeile ausfhren, auch fr RUN, GOTO, GOSUB
 cmp si,[TXTUNF] ;Programmende ?
 jae finish3     ; ja
 mov [CURRNT],si ; nein, neuer Zeilenanfang
 inc si ;Z.nummer berspringen
 inc si
 jmp runsamel
finish2:
 mov bl,144 ;ERROR 144: zuviel Daten
 jmp NERROR
finish4:
 mov bl,255 ;ERROR 255: Abbruch mit <Fn>+<B>
 jmp NERROR
finish3:
 jmp RSTART ;Programmende


FIN:
;testet bei [SI] ob der Befehl zu ende
;ist. wenn ja (0EH oder 0DH) wird der
;nchste Befehl, sonst zum Aufrufer zurck
 endtst   ;Trennzeichen ?
 jnc fin1 ; nein
 pop ax   ; ja, alte Returnadresse
 jmp FINISH ;nchster Befehl
fin1:
 ret


BDATA:
;DATA daten,daten,...   wirkt im Programmlauf wie REM
 jmp RUNNEXTL


BREAD:
 call VGETIA
bread1:
 push si
 push ax      ;Var.typ
 push di      ;Var.adr.
 mov  si,[DAT_PTR]
bread5:
 cld
 lodsb
 cmp  al,0a6h ;DATA-Token
 jz   bread2
 cmp  al,','  ;Komma als Datentrenner
 jz   bread2
 cmp  al,0dh  ;Zeilenende
 jz   bread3
bread4:
 mov  bl,149  ;Fehler: keine Daten
 jmp  NERROR
bread3:
 cmp  si,[TXTUNF]
 jnc  bread4  ;Programmende
 add  si,zuetb        ;berlies Zeilennummer und Lngenbyte
 jmp  bread5
bread2:
 call TSTNUM
 or   ch,ch
 jz   bread4  ;keine Zahl
 pop  di      ;Var.adr.
 pop  ax
 call VSETV   ;setze Variable
 xor  ah,ah   ;berlies evtl. folgende Spaces
 call IGNBLNK
 mov  [DAT_PTR],si
 pop  si
 cmp  b[si],092h ;evtl. weitere Variablen (Komma)
 jnz  bread6
 inc  si
 jmp  BREAD
bread6:
 jmp  FINISH


F_CNAME:
;liefert in DX Adresse des Filenamens (wertet dazu Stringausdruck aus)
;Der Filename liegt irgendwo im BUFFER mit $00 am Ende.
;in:  SI: Textzeiger
;out: SI: -"-   hinter Stringausdruck
;     DX: zeigt auf erstes Byte des Filenamens
;     Flags: Filename mit mind. 1Zeichen: NC
;            kein String oder Leerstring: C
 mov  bx,[BUFFER] ;hierher String
 mov  cx,007fh    ;max. 127 Zeichen
 call STREXP
 jc   f_cname0
 mov  dx,bx   ;Anfang Filename
 add  bx,ax
 mov  b[bx],0 ;$00 dahinter
 or   ax,ax
 clc
 jnz  f_cname0
 stc
f_cname0:
 ret


DLOAD:
;LOAD "filename.ext"   ldt ein Basicprogramm
 CALL F_CNAME
 mov  al,151
 jc   F_OPERR
 push si
 MOV  AX,03D00H
 INT  021H   ;INT$21 Func$3D: Datei ffnen
 JC   F_OPERR
 MOV  DX,TXTBGN
 MOV  CX,[TXTEND]
 SUB  CX,DX
 DEC  CX     ;maximal zu lesende Byte
 PUSH AX     ;handle sichern
 MOV  BX,AX  ;handle
 MOV  AH,03FH
 INT  021H   ;INT$21 Func$3F: Byte lesen
 POP  BX     ;handle
 PUSH AX     ;Anzahl gelesener Byte
 PUSHF       ;Flags
 MOV  AH,03EH
 INT  021H   ;INT$21 Func$3E: Datei schlieen
 POPF
 POP  AX
 JC   F_OPERR
 MOV  DX,TXTBGN
 ADD  DX,AX
 mov  bx,[TXTUNF]
 MOV  [TXTUNF],DX
 pop  si
 cmp  bx,[CURRNT] ;falls im Direktmodus, Zeile fortsetzen
 jc   dload1      ;sonst Programm mit RUN neu starten
 jmp  RUN
dload1:
 jmp  FINISH


F_OPERR:
;Fehler vor/bei Dateioperation (DLOAD/DSAVE)
 MOV  BL,AL
 JMP  NERROR


DSAVE:
;SAVE "filename.ext"   speichert das Basicprogramm
 CALL F_CNAME
 mov  al,151
 jc   F_OPERR
 push si
 cmp  w[TXTUNF],TXTBGN
 jz   DSAVE2 ;nichts da zum Speichern
 PUSH DX     ;Adresse Filename sichern
 XOR  CX,CX  ;Dateiattribut
 MOV  AX,03C00H
 INT  021H   ;INT$21 Func$3C: Datei anlegen
 JC   F_OPERR
 MOV  DX,TXTBGN
 MOV  CX,[TXTUNF]
 SUB  CX,DX  ;Anzahl Bytes
 PUSH CX     ; sichern
 PUSH AX     ;handle sichern
 MOV  BX,AX  ;handle
 MOV  AH,040H
 INT  021H   ;INT$21 Func$40: Byte schreiben
 POP  BX     ;handle holen
 PUSH AX     ;Anzahl wirklich gespeicherter Byte
 PUSHF       ;Flags sichern
 MOV  AH,03EH
 INT  021H   ;INT$21 Func$3E: Datei schlieen
 POPF        ;Flags holen
 POP  AX
 POP  BX
 POP  DX     ;Adresse Filename
 JC   DSAVE3 ;Fehler beim Schreiben
;leider liefert der Portfolio auch ein Carry, wenn er weniger
;Byte als angegeben geschrieben hat (normaler PC nicht)
;aber die geschriebene Bytezahl in AX ist ein Vielfaches von 080H,
;und echte Fehlernummern sind kleiner
 CMP  AX,BX  ;dieser Test erfolgt nur, falls DOS-Fehler entfllt
 JZ   DSAVE2 ;alles ok.
 MOV  AL,135 ;fr Disk voll
DSAVE3:
 PUSH AX     ;Fehlernummer sichern
 MOV  AH,041H
 INT  021H   ;INT$21 Func$41: Datei lschen
 POP  AX
 TEST AL,07FH ;wegen des DOS-Fehlers
 JNZ  F_OPERR ;hier nochmal auf Disk voll testen
 MOV  AL,135
 JMP  F_OPERR ;Fehler melden
DSAVE2:
 pop  si
 jmp  FINISH


LIST:
;LIST zeile   listet Programm ab Zeile
;LIST   listet ab erster Zeile
 clr  bx     ;Zeilennummer = 0
 endtst      ;folgt Z.n. ?
 jc   list1
 call IEXP   ;Zeilennummer holen
list1:
 push si
 call FNDLN  ;suche Zeile
 jc   list4  ;Textende
list2:
 call PRTLN  ;liste Zeile
 call GETKEY ;hole Tastendruck
 cmp  al,020h
 jnz  list4  ;nur bei Leertaste fortsetzen
 cmp  si,[TXTUNF] ;Textende erreicht ?
 jc   list2
list4:
 pop  si
 jmp  FINISH ;Textende erreicht


PRINT:
;druckt den (Text)Ausdruck ab [SI] aus
;folgende Steuerzeichen:
;  Strings (Direktstrings)
;  ; ($95) zum Trennen der Ausdrcke bzw. am Ende zur Verhinderung von CRLF
;  \(expr) ($8c) zum direkten Ausgeben von Codes
 endtst       ;Befehlsende
 jnc  print1
print0:
 call CRLF    ;Befehlsende, also CRLF ausgeben
 call VERKUR
 jmp  FINISH
print1:
 cmp  b[si],08ch ;\(expr)
 jnz  print5
 inc  si
 call IPARN      ;Zeichen direkt ausgeben
 mov  ax,bx
 call CHROUT
 jmp  print3
print5:
;Wenn Stringausdruck, diesen drucken
 mov  bx,[BUFFER] ;Platz fr Stringergebnis
 mov  cx,0080h    ;max. 128 Zeichen
 call STREXP
 jc   print6      ;kein Stringausdruck
 mov  cx,ax
 jcxz print3
print2:           ;String drucken
 mov  al,[bx]
 inc  bx
 call CHROUT
 loop print2
 jmp  print3
print6:
 mov  di,FPR0
 call EXP    ;Ausdruck berechnen (das ist die letzte Mglichkeit)
 mov  cl,[PRT_SPC] ;derzeit nur Lowbyte des word genutzt
 call PRTNUM ;Zahl ausgeben
print3:
 cmp  b[si],095h ;Semikolon ?
 jnz  print0 ;fhrt evtl. zum Error 144
 inc  si
 call FIN    ;wenn Befehlsende keine Rckkehr
 jmp  print1


BUSING:
;USING expr   legt Ausgabeformat fr Zahlen fest
 call IEXP
 mov  [PRT_SPC],bx
 jmp  FINISH


BRAD:
;RAD    schaltet trigonometrische Funktionen in den Radiant-Modus
 mov b[TRI_MOD],0
 jmp FINISH


BDEG:
;DEG    schaltet trigonometrische Funktionen in den Grad-Modus
 mov b[TRI_MOD],1
 jmp FINISH


BRESTORE:
;RESTORE expr   setzt DATA-Zeiger auf Zeile expr
 call IEXP
 push si
 call FNDLN  ;suche Zeile
 jc   bgoto2
 jnz  bgoto2 ;nicht gefunden
 add  si,zuetb
 mov  [DAT_PTR],si
 pop  si
 jmp  FINISH


GOTO:
;GOTO expr   geht zu Zeile expr
 call IEXP
 call FNDLN  ;Ziel suchen
 jc   bgoto2 ; Programmende
 jnz  bgoto2 ; nicht gefunden
 jmp  RUNTHISL ; gefunden
bgoto2:      ;auch BRESTORE, GOSUB
 mov  bl,140 ;Fehler: Zeile nicht gefunden
 jmp  NERROR


GOSUB:
;GOSUB zeile  ruft ein Basic-Unterprogramm ab zeile auf
 cmp  sp,[STKLMT]
 jb   bstkover ;Basic-Stackberlauf
 call IEXP    ;hole Zeilennummer
 push si     ;sichere Zeiger
 call FNDLN  ;suche Sprungziel
 jc   bgoto2 ;Programmende
 jnz  bgoto2 ;nicht gefunden
 push [CURRNT] ;sichere alten Zeilenanfang
 mov  ax,0102H ;$01: GOSUB, $02: words zustzlich auf Stack
 push ax
 jmp  RUNTHISL ;dann starte neue Zeile


RETURN:
;RETURN   setzt das Programm hinter dem aufrufenden GOSUB fort
 pop  bx          ;$01 GOSUB-Kennung?
 cmp  bh,01h
 jnz  bmissbeg
 pop  [CURRNT]
 pop  si
 jmp  FINISH


bstkover:
 mov  bl,146 ;Basic-Stackberlauf
 jmp  NERROR

bmissbeg:
 mov  bl,141 ;kein GOSUB fr RETURN, kein FOR fr NEXT,...
 jmp  NERROR


FOR:
;FOR variable=expr1 TO expr2 STEP expr3
 cmp  sp,[STKLMT]
 jb   bstkover  ;Basic-Stackberlauf
 call SETVAL    ;setze Laufvariable auf Startwert
 cmp  al,1
 jnz  bfor5     ;nur normale 32Bit Integer Var. zugelassen
 push di        ;sichere Variablenadresse
 cld
 lodsb
 cmp  al,093h ;TO vorhanden?
 jz   bfor1
bfor5:
 mov  bl,136  ;Fehler: TO fehlt, keine Int.Var.
 jmp  NERROR
bfor1:        ;TO:
 CALL IEXP    ;ermittle Endwert (Integer)
 push bx     ;sichern
 push dx
 cmp  b[si],094h ;STEP vorhanden ?
 jnz  bfor2
 inc  si   ;STEP: Schrittweite (Integer)
 call IEXP
 jmp  bfor4
bfor2:
 mov  bx,1 ;kein STEP, also STEP 1
 clr  dx
bfor4:
 push bx   ;sichere STEP
 push dx
 push [CURRNT] ;sichere Zeilenanfangsadresse
 push si       ;und Textzeiger
 mov  ax,0207h ;$02: FOR, $07: words zustzlich
 push ax
 jmp  FINISH   ;nchsten Befehl


NEXT:
;NEXT variable
 call VGETIA      ;hole Variablenadr.
 mov  bp,sp       ;da [sp] nicht geht, sondern nur [bp]
 cmp  w[bp],0207h ;FOR-Kennung ?
 jnz  bmissbeg
 cmp  [bp]+14,di  ;Var.adr. von 'FOR'
 jnz  bmissbeg    ;NEXT ohne entsprechendes FOR
 mov  bx,[di]     ;DXBX = Laufvariable
 mov  dx,[di+2]
 add  bx,[bp+8]   ;um STEPwert erhhen
 adc  dx,[bp+6]
 mov  [di],bx     ;und wieder in Variable
 mov  [di+2],dx   ;****direkter Zugriff auf 32 Bit Integer Var.****
 mov  ax,[bp+12]  ;CXAX = Endwert
 mov  cx,[bp+10]
 test w[bp+6],08000h ;falls Step negativ,
 jz   nx2         ;DXBX und CXAX tauschen
 xchg bx,ax
 xchg dx,cx
nx2:
 sub  ax,bx
 sbb  cx,dx
 jl   nx3         ;Schleife beenden
 mov  bx,[bp+4]   ;Schleife nochmal durchlaufen
 mov  [CURRNT],bx
 mov  si,[bp+2]
 jmp  FINISH
nx3:
 add  sp,16  ;Kennung und alles stimmte ja
 jmp  FINISH ;(das schnellste POP)


BEXIT:
;EXIT expr   lscht soviel Scleifen vom Stack (FOR/NEXT, GOSUB/RETURN)
 call IEXP
 or   bx,bx
 jnz  bexit1
bexit2:
 pop  cx     ;expr=0, also hole alles vom Stack
 push cx
 jcxz bexit4 ;Stack gelehrt
 call bexitup
 jmp  bexit2
bexit1:
 pop  cx     ;hole expr Elemente vom Stack
 push cx
 jcxz bexit3 ;Fehler: Stack enthielt nicht genug
 call bexitup
 dec  bx
 jnz  bexit1
bexit4:
 jmp  FINISH
bexit3:      ;auch fr BUNTIL
 jmp  bmissbeg

bexitup:
;lscht ein Stackelement, das vorhanden sein mu
 pop  dx ;eigene Rckkehradr.
 pop  cx ;Kennung, im Lowbyte Anzahl der word
 xor  ch,ch
bexitup1:
 pop  ax
 loop bexitup1
 jmp  dx ;statt eines RET


BREPEAT:
;REPEAT: xxx :UNTIL expr   wiederhole solange expr=0
 cmp  sp,[STKLMT]
 jae  brepeat1
 jmp  bstkover
brepeat1:
 push [CURRNT]
 push si       ;Textzeiger
 mov  ax,0302h ;Kennung
 push ax
 jmp  FINISH


BUNTIL:
;UNTIL expr  Schleifenende fr REPEAT
 call IEXP
 pop  ax
 pop  cx
 pop  di
 cmp  ax,0302h ;$03 REPEAT
 jnz  bexit3
 or   bx,dx
 jnz  buntil1  ;Bedingung erfllt, Ende
 push di       ;Bed. nicht erfllt, wiederhole Schleife
 push cx
 push ax
 mov  [CURRNT],di
 mov  si,cx
buntil1:
 jmp  FINISH


IFF:
;IF expr : befehle
;ist expr 0, wird in der nchsten Zeile fortgesetzt,
;sonst in der gleichen Zeile die Befehle
 call IEXP
 or bx,dx   ;expr=0 ?
 jz REM     ; ja
 jmp FINISH ; nein


REM:
;ignoriert Rest bis zum Zeilenende (Kommentar)
 jmp RUNNEXTL


INPUT:
;INPUT variable   wartet auf Eingabe einer
;Zahl und weist diese der Variablen zu,
;der Endetastencode kommt nach Bit31-16 von ER
 call VGETIA ;Variable
 push si     ;Textzeiger
 push ax
 push di     ;Variablenadresse
 mov  si,[BUFFER] ;Eingabe holen
 call GFSE_AL
 mov  di,[VARREG] ;Ende-Code nach Highword von ER
 mov  [di+46],ax
 call TSTNUM  ;Zahl wandeln
 pop  di
 pop  ax
 call VSETV
 pop  si      ;Textzeiger
 jmp  FINISH


DEFLT:
;Wertzuweisung ohne LET
LET:
;Wertzuweisung LET variable=expr
 call SETVAL
 jmp  FINISH

;*************************************************
;
;        B A S I C F U N K T I O N E N
;
;*************************************************

BFILE:
;handlewert = FILE(funktion,dateiname)
;File anlegen, ffnen, lschen, Verzeichnis anlegen, lschen, wechseln
;handlewert = FILE(handle)   file handle schlieen
 cld
 lodsb
 cmp al,090h ;( ?
 jz bfile0
bfile2:
 mov bl,142
 jmp NERROR ;irgendein Syntaxerror
bfile0:
 push di   ;Adresse fr handlewert
 call IEXP ;funktion oder handle holen
 cmp b[si],092h ;, ?
 jnz bfile9     ;nein, also handle schlieen
 inc si
 push bx      ;funktion sichern
 call F_CNAME ;dateiname auswerten, Adresse in DX
 jc bfile2    ;Fehler, kein dateiname
 pop bx
 mov ah,7
 and ah,bl
 add ah,039h ;aus 0 wird Func$39 usw.
 clr cx      ;nur fr Func$3C der Attributcode
 cmp ah,03ch ;Func$39 make dir, $3A remove dir
 jbe bfile4  ;Func$3B change dir, $3C create file
 cmp ah,03fh
 ja bfile1
 sub ah,03dh ;Func$3D open file
 mov al,ah   ;Zugriffscode
 mov ah,03dh
 jmp bfile4
bfile1:
 mov ah,041h ;Func$41 delete file
 jmp bfile4
bfile9:
 mov ah,03eh ;Func$3E : schliee handle
bfile4:
 push si
 int 021h  ;INT$21
 pop si
 mov bx,ax ;handle oder Fehlercode
 mov dx,0  ;nicht clr dx !!!
 rcl dx,1  ;Carry-Flag als Fehlerindikator nach Bit16
 pop di ;Adresse fr handlewert
 cld
 lodsb
 cmp al,091h ;) ?
 jnz bfile2
 jmp bgkey2  ;32 Bit Integer zurckgeben


BGET:
;byte=GET(handle)   liest ein Byte aus handle file
;ist byte >65535, dann Fehler in Bit15-0
 push di
 call IPARN  ;handle holen (in BX)
 push si
 mov dx,FPR0 ;als Lesepuffer
 mov cx,1    ;1 Byte lesen
 mov ah,03fh
 int 021h    ;INT$21 Func$3F  read from file
 pop si
 pop di
 jc bget1    ;Fehler
 mov bh,0    ;evtl. ok
 mov bl,[FPR0]
 or ax,ax    ;null Byte gelesen da end of file ?
 jz bget1
 jmp bgkey1  ;ok
bget1:
 mov dx,1
 mov bx,ax
 jmp bgkey2


BPUT:
;error=PUT(handle,byte)   schreibt Byte in handle file
 push di
 call TWO_IPARN
 mov [FPR0],al ;byte in Schreibpuffer
 push si
 mov dx,FPR0
 mov cx,1  ;1 Byte schreiben
 mov ah,040h
 int 021h  ;INT$21 Func$40  write to file
 pop si
 pop di
 mov dx,0
 jc bput1  ;Fehler
 shr ax,1  ;falls AX<1, auch Fehler, da Medium voll
 cmc
bput1:
 rcl dx,1
 mov bx,ax
 jmp bgkey2


BGKEY:
;word=GKEY   wartet auf Tastendruck und liefert den Tastencode
 call GETKEY
 mov  bx,ax
bgkey1:
 clr  dx
bgkey2:
 mov  w[di],0
 mov  [di+2],bx
 mov  [di+4],dx
 ret


BTKEY:
;long=TKEY   testet ob Tastendruck vorliegt und liefert
; 0=nein, 1=ja
 push si
 push di
 mov  ah,0bh
 int  021h   ;INT$21 Func$0B: ermittele Standard-Eingabe-Status
 clr  bx
 shr  al,1
 rcl  bx,1
 pop  di
 pop  si
 jmp  bgkey1


RND:
;word=RND(expr) liefert Zufallszahl 0<=zahl<expr<65536 in DXBX
 call IPARN
 or   dx,dx
 jnz  RND2  ;Zahl zu gro
 OR   BX,BX
 JNZ  RND1  ;darf nicht null sein
RND2:
 MOV  BL,139
 JMP  NERROR
RND1:
 PUSH BX     ;Zahl sichern
 MOV  DX,[RND_SRG] ;Zufallszahl ermitteln
 MOV  BX,[RND_CNT]
 MOV  AL,3
 AND  AL,BL
 ADD  DX,BX
 INC  BX
 MOV  [RND_CNT],BX
 MOV  BX,RND_BIT
 XLAT        ;AL=[BX+AL]
 MOV  CL,AL
 MOV  BX,DX
 RCR  BX,CL
 CMC
 RCL  DX,1
 MOV  [RND_SRG],DX
 mov  ax,dx
 clr  dx
 pop  cx
 div  cx
 mov  bx,dx
 jmp  bgkey1


BABS:
;absoluter_Betrag=ABS(expr)
 call PARN
;!Achtung bei Integer!: -2147483648=ABS(-2147483648)
 jmp  CHKSGN


BFRAC:
;Zahl_ohne_Vorkommastellen=FRAC(expr)
 call PARN
 call CINFP
 jmp FLFRAC


BFIX:
;Zahl_ohne_Nachkommastellen=FIX(expr)
 call PARN
 call CINFP
 jmp FLFIX


BSQR:
;Quadratwurzel=SQR(expr)
 call PARN
 call CINFP
 call FLSQRT
 jc bexpg1
 ret


BLOGN:
;natrlicher_Logarithmus=LOGN(expr)
;wenn expr=0, wird 0 geliefert
 call PARN
 call CINFP
 call FLLOGN
 jc bexpg1
 ret


BLOGG:
;dekadischer_Logaritmus=LOGG(expr)
 call PARN
 call CINFP
 call FLLOGG
 jc bexpg1
 ret


BEXPG:
;zehn_hoch_x=EXPG(x)
 call PARN
 call CINFP
 call FLEXPG
 jnc ret
bexpg1:
 mov bx,[VARREG]
 or b[bx+44],080h ;ER Bit7 =1
 ret


BEXPN:
;e_hoch_x=EXPN(x)
 call PARN
 call CINFP
 call FLEXPN
 jc bexpg1
 ret


btrigon:
;gemeinsam fr SIN, COS, TAN, besorgt Argument und wandelt in Radiant
 call PARN
 call CINFP
 test b[TRI_MOD],0ffh
 jz btrigon0
 mov bp,CONSTGRRA
 call FLMUL
btrigon0:
 ret
CONSTGRRA:
 dw 0a000h
 db 020h,025h,029h,053h,074h,001h ;x * 2*pi/360


BSIN:
;sinus=SIN(x)   x in Radiant
 call btrigon
 jmp FLSIN ;ret gespart


BCOS:
;cosinus=COS(x)   x in Radiant
 call btrigon
 jmp FLCOS ;ret gespart


BTAN:
;tangens=TAN(x)   x in Radiant
 call btrigon
 mov bp,FPR1   ;tan(x)=sin(x)/cos(x)
 call FLMOVR
 call FLSIN
 push di
 mov di,FPR1
 call FLCOS
 pop di
 mov bp,FPR1
 call FLDIV
 jc bexpg1     ;Fehler, /0
 ret


BPI:
;3.1415926536=PI   Wert der Konstanten (aufgerundet)
 mov bp,CONSTPI
 jmp FLMOVV ;ret gespart


BHIB:
;Highbyte=HIB(expr), liefert das Highbyte des Lowword
 call IPARN
 mov  bl,bh
 clr  bh
 jmp  bgkey1


BCINT:
;integer=CINT(expr)  wandelt expr in Integer
 call PARN
 jmp  CFPIN


BCDBL:
;float=CDBL(expr)  wandelt expr in Float
 call PARN
 jmp  CINFP


BFRE:
;word=FRE liefert Anzahl freier Byte
;zwischen [TXTUNF] und [TXTEND]
 MOV  BX,[TXTEND]
 SUB  BX,[TXTUNF]
 jmp  bgkey1


BBIT:
;bitwert=BIT(bitnummer,expr)
;liefert 0 wenn Bit bitnummer in expr =0, sonst -1
 call TWO_IPARN ;DI wird nicht verndert
 xchg bx,cx
 and cx,01fh
 inc cx
 clr dx ;Bit nummer CX-1 in BXAX testen
bbit1:
 shr bx,1
 rcr ax,1
 loop bbit1
 sbb dx,dx ;aus 0 wird $ffff wenn C-Flag gesetzt
 mov bx,dx
 jmp bgkey2


BPOINT:
;farbe=POINT(x,y)   liefert die Farbe des Punktes (x,y)
 call TWO_IPARN
 XOR  CH,CH
 XOR  DH,DH
 MOV  CL,BL
 MOV  DL,AL
 CALL PTEST
 SUB  AH,AH
 mov bx,ax
 jmp bgkey1


INP:
;byte=INP(portadr) wie 8088 IN-Befehl
 call IPARN
 mov  dx,bx
 in   al,dx
 mov  bl,al
 clr  bh
 jmp  bgkey1


PEEK:
;byte=PEEK(adr)  liefert byte von DS:adr
 CALL IPARN
 MOV  BP,[VARREG]
 MOV  ES,[BP+32]
 ES:MOV  BL,[BX]
 clr  bh
 mov_esds
 jmp  bgkey1


WPEEK:
;word=WPEEK(adr)  liefert word von DS:adr
 CALL IPARN
 MOV  BP,[VARREG]
 MOV  ES,[BP+32]
 ES:MOV BX,[BX]
 mov_esds
 jmp  bgkey1


LPEEK:
;long=LPEEK(adr)  liefert 32 Bit Wert von DS:adr
 call IPARN
 mov  bp,[VARREG]
 mov  es,[bp+32]
 es:mov dx,[bx+2]
 es:mov bx,[bx]
 mov_esds
 jmp  bgkey2

;*****************Ende der Basicfunktionen*************

GRAPHICS:
;GRAPHICS expr   schaltet den Bildmodus ein
 CALL IEXP
 CMP  BX,128
 JZ   GRAP1
 CMP  BX,0
 JNZ  GRAP2
 CALL STEXTM    ;Text einschalten
 MOV  AX,0135H  ;Kursor auf (0,0)
 CALL PFSE_C    ;mit Steuercode HOM
 JMP  FINISH
GRAP1:
 PUSH SI        ;Graphik 240*64 Pixel ein
 MOV  [G_MO],BL ;oder 640*350 (2 Farben), nur 240*64 genutzt
 #if portfolio
 MOV  AX,000AH
 #else
 MOV  AX,0006H
 #endif
 INT  010H      ;INT$10 Func$00
 POP  SI        ;clipping setzen
 MOV  W[G_AX],0      ;(G_AX,G_AY)=(0,0)
 MOV  W[G_EX],03FEFH ;(G_EX,G_EY)=(239,63)
 MOV  W[G_HX],040F0H ;
 MOV  B[G_CO],1 ;COLOR setzen
 MOV  W[G_X],0  ;Kursor setzen (G_X,G_Y)=(0,0)
 mov  w[G_RO],0 ;Graphiktextinfos
 mov  w[G_ZG],GRAPZG
 JMP  FINISH
GRAP2:
 MOV  BL,131    ;falscher Graphikmodus
 JMP  NERROR


TOTEXTM:
;schaltet Textmodus ein falls nicht an
;setzt in jedem Fall das Clipping neu
 mov  b[T_MO],0 ;Steuersequenz aus
 CMP  B[G_MO],128
 JZ   TOTEXTM1 ;Graphik war an
 PUSH SI       ;Text war an,
 JMP  STEXTM2  ;nur Clipping setzen
TOTEXTM1:
 call STEXTM
 mov  ax,0135h ;Kursor auf 0,0
 call PFSE_C   ;mit Steuercode HOM
 ret


STEXTM:
;schaltet den TEXT-Modus ein
;und setzt Clipping, aber nicht den Kursor (wegen TOTEXTM)
;auf XT/AT: BIOS-Modus 7 (Hercules), oder Modus 3 (CGA/EGA/VGA)
;           setzt SCRNADR entsprechend
;auf Portfolio: BIOS-Modus 7 und 80*25 statisch
 PUSH SI
 MOV  DL,0
 MOV  [G_MO],DL
 #if portfolio
 MOV  AX,0E01H
 INT  061H      ;INT$61 Func$0E: Portfolio-Bildmodus setzen
 #endif
 mov w[SCRNADR],0b000h  ;Segmentadr fr Hercules
 MOV  AX,0007H  ;Modus 7
 INT  010H      ;INT$10 Func$00: Bildmodus setzen
 #if !portfolio ;nur fr nicht Portfolio
 mov ah,0fh
 int 010h       ;INT$10 Func$0F: Bildmodus erfragen
 cmp al,7
 jz STEXTM2     ;ok, Mode 7 gesetzt
 mov w[SCRNADR],0b800h  ;Segmentadr fr CGA/EGA/VGA
 mov ax,0003h   ;Modus 3
 int 010h       ;INT$10 Func$00: Bildmodus setzen
 #endif
STEXTM2:        ;fr TOTEXTM
 MOV  W[G_AX],0 ;clipping setzen: G_AX und G_AY
 MOV  W[G_EX],0184FH ;G_EX, G_EY
 MOV  W[G_HX],01950H ;G_HX, G_HY
 MOV  AH,0FH    ;aktive Seite holen
 INT  010H      ;INT$10 Func$0F: Videomodus lesen
 MOV  [G_PA],BH ;Nummer der Bildseite, meist 0
 POP  SI
 call VERKUR
 RET


BPLOT:
;PLOT x,y  setzt Punkt auf (x,y)
 CALL TWO_EX
 MOV  [G_X],BL
 MOV  [G_Y],AL
 mov  dx,ax   ;Highbytes lscht PLOT
 mov  cx,bx
 CALL PLOT
 JMP  FINISH


PLOT:
;setzt Punkt auf CL,DL   Farbe aus [G_CO]
 PUSH AX
 allpush
 XOR  CH,CH
 XOR  DH,DH
 CMP  CL,[G_AX] ;testen ob innerhalb des clipping
 JC   PLOT2
 CMP  CL,[G_EX]
 JA   PLOT2
 CMP  DL,[G_AY]
 JC   PLOT2
 CMP  DL,[G_EY]
 JA   PLOT2
 MOV  AL,[G_CO] ;Farbe holen
 OR   AL,AL
 JNS  PLOT1
 CALL PTEST  ;Punktfarbe von (CX,DX) holen in AL
 XOR  AL,1   ;und negieren
PLOT1:
 AND  AL,1   ;nur Bit0 als Farbe
 MOV  AH,0CH ;Punkt setzen
 INT  010H   ;INT$10 Func$0C
PLOT2:
 allpop
 POP  AX
 RET


PTEST:
;liefert in AL die Farbe des Graphikpunktes auf (CX,DX)
 push di
 push si
 PUSH ES
 PUSH BX
 PUSH CX
 PUSH DX
 #if portfolio
 SHL  DX,1  ;Zeile zu 30 Byte
 MOV  BX,DX ;30=(32-2)
 SHL  BX,1
 SHL  BX,1
 SHL  BX,1
 SHL  BX,1
 SUB  BX,DX ;Adresse in BX, DX ist frei
 MOV  DX,CX
 SHR  DX,1  ;Spalte mit 8 Bit je Byte
 SHR  DX,1
 SHR  DX,1
 ADD  BX,DX ;Adresse + Spalte
 AND  CL,7
 INC  CL
 SUB  AL,AL
 MOV  DX,0B000H ;Segmentadresse
 MOV  ES,DX
 ES:  MOV  DL,[BX]
 SHL  DL,CL
 RCL  AL,1
 #else
 mov  ah,0dh
 int  010h   ;INT$10 Func$0D: Graphikpunkt lesen
 #endif
 POP  DX
 POP  CX
 POP  BX
 POP  ES
 pop  si
 pop  di
 RET


DRAW:
;zieht Linie von (CX,DX) nach (AX,BX)
;zerstrt alle Register
 sub  sp,10     ;Platz fr 4 word auf Stack
 mov  bp,sp     ; mit bp als Index
 mov  [bp+4],ax ;speichere X2
 mov  [bp+6],bx ;speichere Y2
 mov  di,1      ;RX=1
 sub  ax,cx     ;DX=X2-X1
 jns  dra1
 neg  di        ;RX=-1
 neg  ax        ;DX=-DX
dra1:
 mov  [bp],di
 mov  di,1      ;RY=1
 sub  bx,dx     ;DY=Y2-Y1
 jns  dra2
 neg  di        ;RY=-1
 neg  bx        ;DY=-DY
dra2:
 mov  [bp+2],di
 mov  si,ax     ;S=DX
 cmp  ax,bx
 jge  dra3
 mov  si,bx     ;S=-DY
 neg  si
dra3:
 add  ax,ax     ;DX=2*DX
 add  bx,bx     ;DY=2*DY
dra4:
 call PLOT      ;Punkt setzen (cx,dx)
 cmp  [bp+4],cx
 jne  dra5
 cmp  [bp+6],dx
 jne  dra5
 add  sp,10     ;Ende
 ret
dra5:
 or   si,si
 js   dra6
 add  cx,[bp]   ;X1=X1+RY
 sub  si,bx     ;S=S-DY
 jnc  dra4
 add  dx,[bp+2] ;Y1=Y1+RY
 add  si,ax     ;S=S+DX
 jmp  dra4
dra6:
 add  dx,[bp+2] ;Y1=Y1+RY
 add  si,ax     ;S=S+DX
 jnc  dra4
 add  cx,[bp]   ;X1=X1+RX
 sub  si,bx     ;S=S-DY
 jmp  dra4


DRAWTO:
;DRAWTO x,y   zieht Linie vom alten Kursor nach (x,y)
 CALL TWO_EX
 PUSH SI
 XCHG AX,BX
 MOV  CL,[G_X]
 MOV  DL,[G_Y]
 SUB  AH,AH
 MOV  DH,AH
 MOV  CH,AH
 MOV  BH,AH
 MOV  [G_X],AL
 MOV  [G_Y],BL
 CALL DRAW
 POP  SI
 JMP  FINISH


POSITION:
;POSITION x,y   positioniert den (Graphik-)Kursor
 CALL TWO_EX
 MOV  CL,[G_MO]
 OR   CL,CL
 JNS  POSI1    ;im Textmodus
 MOV  BH,AL    ;im Graphikmodus (das CLIP erledigt PLOT)
 MOV  [G_X],BX ;G_X und G_Y setzen
 JMP  FINISH
POSI1:
 CMP  AL,[G_AY] ;CLIP-Grenzen testen
 JC   POSI2
 CMP  AL,[G_EY]
 JA   POSI2
 CMP  BL,[G_AX]
 JC   POSI2
 CMP  BL,[G_EX]
 JA   POSI2
 PUSH DX
 MOV  DH,AL
 MOV  DL,BL
 MOV  [G_X],DX  ;G_X und G_Y setzen
 CALL SETBICU
 POP  DX
POSI2:
 JMP  FINISH


BCLIP:
;CLIP anfx,anfy TO endx,endy   setzt clipping-Variablen
;vertauscht evtl. anfx und endx, anfy und endy so da anf<end
 CALL TWO_EX ;anfx, anfy holen
 MOV  BH,AL
 PUSH BX
 cmp  b[si],093h ;TO ?
 jnz  BCLIP1
 inc  si
 CALL TWO_EX ;endx, endy holen
 MOV  BH,AL  ;BL:endx, BH:endy
 POP  AX     ;AL:anfx, AH:anfy
 CMP  AL,BL
 JC   BCLIP2
 XCHG AL,BL
BCLIP2:
 CMP  AH,BH
 JC   BCLIP3
 XCHG AH,BH
BCLIP3:
 mov  cx,[G_HX]
 cmp  bl,cl     ;es reicht den greren Wert zu testen
 jae  bclip7
 cmp  bh,ch
 jae  bclip7
 MOV  [G_AX],AX ;G_AX, G_AY
 MOV  [G_EX],BX ;G_EX, G_EY
 MOV  [G_X],AX  ;G_X, G_Y
 cmp  b[G_MO],0
 jnz  bclip4
 MOV  DX,AX
 CALL SETBICU
 call VERKUR
bclip4:
 JMP  FINISH
BCLIP1:
 MOV  BL,132
 JMP  NERROR
bclip7:
 mov  bl,143 ;Clipping auerhalb Hardware
 jmp  NERROR


COLOR:
;COLOR expr  setzt die Farbe
 CALL IEXP
 MOV  [G_CO],BL
 JMP  FINISH


BTMODE:
;TMODE expr   setzt den Textwinkel
 call IEXP
 and  bx,7  ;nur 0 bis 7
 add  bx,bx ;und * 6
 mov  [G_RO],bx
 add  bx,bx
 add  [G_RO],bx
 jmp  FINISH


BPMODE:
;PMODE expr   legt Ausgabeumleitung fest
 call IEXP
 mov  [PRT_WAY],bx
 and  bh,2
 jz   bpmode1
 push si     ;Drucker LPT1 initialisieren
 clr  dx
 mov  ah,1
 int  017h   ;INT$17 Func$01: initialisiere LPTx
 pop  si
bpmode1:
 jmp  FINISH


SOUND:
;gibt Ton aus
;in:  BX: Frequenz in Hertz
;     CX: Dauer in 1/100 Sekunden
 #if portfolio
 PUSH AX
 PUSH DX
 XOR  DI,DI
 MOV  BP,TABSF-2
SOUND1:
 INC  DI
 INC  BP
 CMP  BX,[BP+DI]
 JC   SOUND1
 MOV  BP,TABSB-1
 XOR  DH,DH
 MOV  DL,[BP+DI]
 MOV  AH,016H
 INT  061H      ;INT$61 Func$16
 POP  DX
 POP  AX
 #endif
 RET

;fr bersetzung der Frequenzwerte in interne Byte
TABSF:
;25+1 Frequenz-Werte (0 als Ende)
 dw 2489,2349,2217,2093,1975,1865,1760,1661,1568,1480
 dw 1397,1318,1245,1175,1109,1046,988,932,880,831,784
 dw 740,699,659,622,0
TABSB:
;26+1 Byte-Werte
 db 7,6,02fh,025h,5,4,03fh,02ch,03eh,0eh,03dh,03ch,03bh
 db 029h,03ah,039h,038h,037h,036h,035h,034h,033h,032h
 db 031h,030h,030h

BSOUND:
;SOUND freqenz_in_hertz,dauer_in_hundertstel_sekunden
;gibt Ton aus
 CALL TWO_EX
 MOV  CX,AX
 CALL SOUND
 JMP  FINISH


OUTCMD:
;OUT portadr,byte wie 8088 OUT-Befehl
 CALL TWO_EX
 mov  dx,bx
 OUT  DX,AL
 JMP  FINISH


POKE:
;POKE adr,byte schreibt auf ES:adr das byte
 CALL TWO_EX
 MOV  BP,[VARREG]
 MOV  ES,[BP+36]
 ES:MOV  [BX],AL
 mov_esds
 JMP  FINISH


WPOKE:
;WPOKE adr,word   schreibt auf ES:adr das word
 CALL TWO_EX
 MOV  BP,[VARREG]
 MOV  ES,[BP+36]
 ES:MOV  [BX],AX
 mov_esds
 JMP  FINISH


LPOKE:
;LPOKE adr,long   schreibt auf ES:adr den 32 Bit Wert
 call TWO_EX
 mov  bp,[VARREG]
 mov  es,[bp+36]
 es:mov [bx],ax
 es:mov [bx+2],cx
 mov_esds
 jmp  FINISH


AKTREG:
;AKTREG
;setzt die Variablen CS, DS, ES auf Interpretersegment
;und BX auf Programmanfang, CX hinter Programmende,
;DX hinter Programmspeicherende
 mov bx,[VARREG]
 mov di,bx
 clr ax
 mov cx,22
 rep stosw
 MOV [BX+28],CS
 MOV [BX+32],CS
 MOV [BX+36],CS
 MOV W[BX+4],TXTBGN
 MOV AX,[TXTUNF]
 MOV [BX+8],AX
 MOV AX,[TXTEND]
 MOV [BX+12],AX
 JMP FINISH


BINTSUB:
;Teil von BINT mit selbstmodifizierendem Code
 INT  021H ;Nummer wird gendert
 RET

BINT:
;INT nummer   ruft einen Interrupt auf
;verwendet dabei die xx-Registervariablen bis auf CS
 CALL IEXP
 MOV  BP,BINTSUB+1
 MOV  [BP],BL
 PUSH SI
 CALL MOVE_VR
 CALL BINTSUB
 CALL MOVE_RV
 POP  SI
 JMP  FINISH


MOVE_VR:
 MOV  BX,[VARREG]
 PUSH [BX]
 PUSH [BX+4]
 MOV  CX,[BX+8]
 MOV  DX,[BX+12]
 MOV  BP,[BX+16]
 MOV  DI,[BX+20]
 MOV  SI,[BX+24]
 ;CS nicht laden !
 PUSH [BX+32]
 PUSH [BX+36]
 MOV  AH,[BX+40] ;Lowbyte in Arithmetikflags
 SAHF
 POP  ES
 POP  DS
 POP  BX
 POP  AX
 RET


MOVE_RV:
 PUSH AX
 PUSH BX
 PUSH DS
 PUSH ES
 MOV  AX,CS ;erstmal DS und ES
 MOV  DS,AX ; wieder einstellen
 MOV  ES,AX
 MOV  BX,[VARREG]
 LAHF
 MOV  [BX+40],AH
 MOV  B[BX+41],0
 POP  [BX+36]
 POP  [BX+32]
 MOV  [BX+24],SI
 MOV  [BX+20],DI
 MOV  [BX+16],BP
 MOV  [BX+12],DX
 MOV  [BX+8],CX
 POP  [BX+4]
 POP  [BX]
 RET


BCALL:
;CALL adresse   Maschinenunterprogrammaufruf
 CALL IEXP
 PUSH SI
 PUSH CS ;Ablegen der Rckkehradresse fr ein RET FAR
 MOV  DX,BCALLR
 PUSH DX
 MOV  BP,[VARREG]
 PUSH [BP+28] ;Ablegen der Zieladresse zum Aufruf mit RET FAR
 PUSH BX
 CALL MOVE_VR
 RET FAR
BCALLR:
 CALL MOVE_RV
 POP  SI
 JMP  FINISH
